# Define templates
include:
  - project: ${GITLAB_CI_TEMPLATES_PATH}
    file: ${GITLAB_CI_TEMPLATES_FILE}
    ref: '1.1.0'

# Define stages
stages:
  - build
  - predeploy
  - deploy
  - test
  - publish
  - release
  - upgrade
  - clean

# Define global variables
variables:
  P_NAME: "pdqm-fhir-simulators"
  P_APP_TYPE: "java"
  P_CODE_SRC_PATH: "."
  P_MAVEN_IMAGE_TAG: "3.8.1-openjdk-17-slim"
  SERVICE_PATH: "${CI_PROJECT_NAME}-service"

# Define jobs
compile/unit-test:
  stage: build
  extends:
    - .buildJavaMavenTest

package:
  stage: build
  extends:
    - .buildJavaMavenPackage
  needs:
    - job: compile/unit-test
      artifacts: true
static-analysis:
  stage: test
  extends:
    - .testJavaMavenSonarAnalysis
  needs:
    - job: compile/unit-test
      artifacts: true

install-cache-repo:
  stage: publish
  extends:
    - .publishJavaMavenInstall
  needs:
    - job: package
      artifacts: true

release/code:
  stage: release
  extends:
    - .releaseCodeForQuarkus


